/*-
 * Copyright (C) @BABOLO  2002 Dec 17
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C) @BABOLO  2002 Dec 17\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: cmd_copy.c,v 1.1 2002/12/17 07:06:35 babolo Exp $";
#endif /* not lint */
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <err.h>
#include <libpq-fe.h>
#include "pgoblin.h"

int
copyout(struct connopt *options, char *query, FILE *out) {
    int k, f;
    size_t i;
    PGresult *res;
    char *q, buf[BUFSIZE];

    if  (shurecon(options)) return(NULL);
    q = (query) ? query : options->query;
    PQEXEC(res, q, PGRES_COPY_OUT, NULL);

    if  (res == NULL) return(-1);
    for (k = 0; (f = PQgetline(options->conn, buf, BUFSIZE)) != EOF && !feof(out) && !ferror(out);) {
        if  (v_flag > 3) fprintf(stderr, "%d%d buf=%s\n", k, f, buf);
        if  (!k && strcmp("\\.", buf) == 0) break;
        if  (f == 1) {
            fwrite(buf, BUFSIZE - 1, 1, out);
        } else {
            i = strlen(buf);
            buf[i] = '\n';
            fwrite(buf, i + 1, 1, out);
        }
        k = f;
    }
    if  ((f = PQendcopy(options->conn)) != 0) {
        if  (v_flag >= 0) warnx("PQendcopy failed: %d", f);
        return(-1);
    }
    PQclear(res);
    return(0);
}

int
bincopyout(struct connopt *options, char *query, FILE *out) {
    int k, f;
    size_t i;
    PGresult *res;
    char *q, buf[BUFSIZE];

    if  (shurecon(options)) return(NULL);
    q = (query) ? query : options->query;
    PQEXEC(res, q, PGRES_COPY_OUT, NULL);

    if  (res == NULL) return(-1);
    for (k = 0; (f = PQgetline(options->conn, buf, BUFSIZE)) != EOF && !feof(out) && !ferror(out);) {
        if  (v_flag > 3) fprintf(stderr, "%d%d buf=%s\n", k, f, buf);
        if  (!k && strcmp("\\.", buf) == 0) break;
        if  (f == 1) {
            fwrite(buf, BUFSIZE - 1, 1, out);
        } else {
            i = strlen(buf);
            buf[i] = '\n';
            fwrite(buf, i + 1, 1, out);
        }
        k = f;
    }
    if  ((f = PQendcopy(options->conn)) != 0) {
        if  (v_flag >= 0) warnx("PQendcopy failed: %d", f);
        return(-1);
    }
    PQclear(res);
    return(0);
}
